#include<reg51.h>
#include<string.h>
#include<stdio.h>
sbit EN=P2^0;
sbit RS=P2^1;
sbit EOC=P2^7;
sbit ADDL=P2^4;
sbit ADCLK=P2^5;
sbit ADCST=P2^6;
sbit FAN=P3^0;
sbit bf=P0^7;
sbit RW=P3^1;
#define ON 1
#define OFF 0
bit flag=0,flget=0,timmerflag=0;
static unsigned int  READ_CURR_TEMP,C_TEMP,S_TEMP;
static unsigned int  SET_TEMP;
#define LINE_2 0xC0
#define LCD_CLR 0x01
#define LCD_INT_2LINE 0x38
#define LCD_ON 0x0C
//#define LCD_PORT P0
#define DATA_R 1
#define CMD    0
char CURRNTTEM[6];
char SETTEMP[6];
void busy()
{
	EN=0;
	P0=0xFF;
	RS=0;
	RW=1;
	while(bf)
	{
		EN=0;
		EN=1;
	}
	EN=0;
	RW=0;
}
void int_to_str(unsigned int a,char q[])
{ 
	char s;
	if(a<100)
	{
		q[0]='0';
		q[3]=(a%10)+'0';
		a/=10;
		q[2]='.';
		q[1]=a+'0';
		q[4]=0xDF;
		q[5]='C';
		q[6]='\0';
	}
	else
	{		
	 s=3;
	while(a/10>0)
	{
		if(s==2)
			q[s]='.';
		else
		{
		q[s]=(a%10)+'0';
		a/=10;
		}
		s--;
	}
	q[0]=a+'0';
	q[4]=0xDF;
	q[5]='C';
	q[6]='\0';
}
}
void delay(int a)
{
	int b,c;
	for(b=0;b<a;b++)
	for(c=0;c<120;c++);
}

void start_clk()
{
	ADCLK=0;
	ADCLK=1;
	//delay(1);
	ADCLK=0;
	//EOC=0;
}
unsigned start_adc_con(unsigned char chanal)
{
	static unsigned char first=1,first1=1;
	static unsigned int t1,t2,t3,t4,t5,t11,t12,t13,t14,t15=0;
	switch(chanal)
	{
		case 0x00:
		{
			P2=(P2&0xF3);
		    ADDL=1;
			delay(1);
		    ADDL=0;
		    break;
		}
		case 0x01:
		{
			P2=(P2&0xF3)|0x04;
	        ADDL=1;
			delay(1);
		    ADDL=0;
		    break;
		}
		default :
			break;
	}
	//for(i=0;i<5;i++)
	{
		ADCST=1;
		EOC=1;
		delay(1);
		ADCST=0;
		do
		{
			start_clk();
		}while(!EOC);
		if(chanal==0x00)
		{
		if(first==1)
		{
			t1=t2=t3=t4=t5=(int)P1;
			first=0;
		}
		
		t5=t4;
		t4=t3;
		t3=t2;
		t2=t1;
		t1=(int)P1;
		return (t1+t2+t3+t4+t5)/5;
       }
	   else
	   {
		   if(first1==1)
		{
			t11=t12=t13=t14=t15=(int)P1;
			first1=0;
		}
		
		t15=t14;
		t14=t13;
		t13=t12;
		t12=t11;
		t11=(int)P1;
		return (t11+t12+t13+t14+t15)/5;
	}
}
}
			
		
	
void EN_()
{
	EN=0;
    EN=1;
    EN=0;
}
void lcd_cmd(unsigned char a)
{
	busy();
RS=0;
P0=a;
EN_();
RS=1;
	}
void lcd_data(unsigned char a)
{
	busy();
    RS=1;
    P0=a;
    EN_();
}
void lcd_str(char *s)
{
	while(*s)
		{
			lcd_data(*s);
			if(flget)
			delay(200);
			s++;
		}
}
void main()
{
	TMOD=0x01;
	TH0=0x4C;
	TL0=0x01;
	ET0=1;
	EA=1;TR0=1;
	ADDL=0;
	ADCLK=0;
	ADCST=0;
	FAN=OFF;
	RW=0;
    lcd_cmd(LCD_INT_2LINE);
    lcd_cmd(LCD_ON);
    lcd_cmd(LCD_CLR);
	//lcd_cmd(0x07);
	//lcd_cmd(0x8F);
	//flget=1;
	lcd_str("  Prepaired for ");
	lcd_cmd(0xC0);
    lcd_str("   (B.K.BIET)    ");
	delay(2000);
	lcd_cmd(0x01);
	lcd_str(" $ Prepared by $");
	lcd_cmd(0xc0);
	lcd_str(" Gaurav & varun");
	delay(2000);
	//flget=0;
	lcd_cmd(0x06);
	a:lcd_cmd(LCD_CLR);
	lcd_cmd(0x80);
	lcd_str("SET_TEMP->");
	lcd_cmd(0Xc0);
    lcd_str("CUR_TEMP->");
	while(1)
	{
		if(timmerflag)
		{
		SET_TEMP=(start_adc_con(0x00)*4);
		if(SET_TEMP>999)
		{
			flag=1;
			{
				lcd_cmd(0x01);
			    lcd_str("  !!WARRNING!!");
			    lcd_cmd(0xC0);
			    lcd_str("Ohh.....TOO HIGH");
		    }
		do
			{
		     SET_TEMP=start_adc_con(0x00)*4;
			}
			while(SET_TEMP>999);
	    }
		else
		{
			if(flag)
			{
				flag=0;
				goto a;
			}
		}
		
			
		S_TEMP=SET_TEMP;
	    int_to_str(SET_TEMP,SETTEMP);
		lcd_cmd(0x8a);
	    lcd_str(SETTEMP);
        READ_CURR_TEMP=(start_adc_con(0x01))*4;
	    C_TEMP=READ_CURR_TEMP;	
        lcd_cmd(0XcA);
		int_to_str(READ_CURR_TEMP,CURRNTTEM);
		lcd_str(CURRNTTEM);
		if(C_TEMP>=S_TEMP)
			FAN=ON;
		else
			FAN=OFF;
		timmerflag=0;
	}
	}
	}
void ISTTO_() interrupt 1 using 0 
	{ char j;
		TR0=0;
		TH0=0x4C;
		TL0=0x01;
		if(++j==1)
		{
			j=0;
			timmerflag=1;
		}
		TR0=1;
	}
			
		
